package webdb.chat;

import java.io.IOException;

import net.sf.json.JSONObject;

import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.NameValuePair;
import org.apache.commons.httpclient.methods.GetMethod;

import flex.messaging.io.amf.ASObject;
import flex.messaging.messages.Message;
import flex.messaging.services.MessageService;
import flex.messaging.services.messaging.adapters.ActionScriptAdapter;

public class ChatTranslationAdapter extends ActionScriptAdapter {

	@Override
	public Object invoke(Message message) {
		// メッセージからbodyを取得
		ASObject msgBody = (ASObject) message.getBody();
		String originalMsg = (String) msgBody.get("msg");
		String translatedMsg = translate(originalMsg);
		String msg = translatedMsg + " (" + originalMsg + ")";
		msgBody.put("msg", msg);
		message.setBody(msgBody);
		// メッセージをプッシュ
		MessageService msgService = (MessageService) getDestination()
				.getService();
		msgService.pushMessageToClients(message, true);
		return null;
	}

	private String translate(String originalMsg) {
		GetMethod get = new GetMethod(
				"http://ajax.googleapis.com/ajax/services/language/translate");
		NameValuePair q = new NameValuePair("q", originalMsg);
		NameValuePair langpair = new NameValuePair("langpair", "|en");
		NameValuePair v = new NameValuePair("v", "1.0");
		NameValuePair[] queryString = new NameValuePair[] { q, langpair, v };
		get.setQueryString(queryString);
		HttpClient client = new HttpClient();
		try {
			int status = client.executeMethod(get);
			if (status == 200) {
				String res = get.getResponseBodyAsString();
				JSONObject json = JSONObject.fromObject(res);
				if (json.getInt("responseStatus") == 200) {
					return json.getJSONObject("responseData").getString(
							"translatedText");
				}
			}
		} catch (IOException e) {
		}
		return originalMsg;
	}

}
